Index: /Interface_Web/trunk/pspaWT/sources/controler/include/abstractElement.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/abstractElement.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/abstractElement.h	(revision 431)
@@ -7,14 +7,7 @@
 
 #include "nomdElements.h"
-//#include "nomDeLogiciel.h"
-//#include "trivaluedBool.h"
 #include "abstractSoftware.h"
-/* #include "softwareGenerator.h" */
-/* #include "softwareParmela.h" */
-/* #include "softwareTest.h" */
-/* #include "softwareTransport.h" */
 
 #include "UAP/UAPNode.hpp"
-
 using namespace std;
 
@@ -26,18 +19,16 @@
   int nbParam_;
   string* parametersString_;
-  double phaseStepMax_;
+  
+  string defaultSpecificName_;
+  string specificName_;
+  nomdElements elementName_;
     
   double defaultLength_;
   double defaultAperture_;
-  string defaultSpecificName_;
-  
-  string specificName_;
-  nomdElements elementName_;
+  double phaseStepMax_;
   
   double lenghtElem_; // cm
   double aperture_; // cm
-  
   double stepmaxcm_;
-  //  bool curvedTrajectory_;
   
   void setDefaultValues();
@@ -51,10 +42,12 @@
   
   void setParameters(double ll,double aper);
+  
+  nomdElements getNomdElement() const;
+  int getNbParams() const;
+
   void setLabel(string lab);
   string getLabel() const;
-  nomdElements getNomdElement() const;
-  
+
   double getLenghtOfElement() const;
-  int getNbParams() const;
   
   virtual void setPhaseStep(double);
@@ -67,5 +60,4 @@
   virtual void FileInput(ifstream& ifs) = 0;
   virtual string print() = 0;
-  
   virtual void InputRep(UAPNode* root) = 0;
 
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/abstractSoftware.h	(revision 431)
@@ -3,4 +3,5 @@
 
 #include "globalParameters.h"
+#include "sectorParameters.h"
 #include "particleBeam.h"
 #include "nomDeLogiciel.h"
@@ -19,21 +20,22 @@
 
  protected :
-
+  
   unsigned numeroDeb_, numeroFin_;
   globalParameters* globParamPtr_;
+  sectorParameters* sectParamPtr_; //xx
   dataManager* dataManager_;
   string inputFileName_;
   nomDeLogiciel nameOfSoftware_;
 
-    /**
+  /**
      Accepted elements list for this software
-     */
+  */
   std::vector <nomdElements::typedElement> acceptedElements_;
 
-    /**
+  /**
      Ignore software list for this element
-     */
+  */
   std::vector <nomdElements::typedElement> ignoredElements_;
-
+  
   abstractSoftware();
 
@@ -42,37 +44,32 @@
   bool ComputationLimitsOk() const;
 
-
   void registerElement(nomdElements::typedElement nomdel,trivaluedBool b);
 
  public :
 
-  abstractSoftware(string inputFileName, globalParameters* globals, dataManager* dt);
+  abstractSoftware(string,globalParameters*,dataManager*);
+  abstractSoftware(string,sectorParameters*,dataManager*);
   ~abstractSoftware() {;}
 
   inline const nomDeLogiciel* getNomDeLogiciel() const {
     return &nameOfSoftware_;
-}
+  }
 
   trivaluedBool doAcceptElement(nomdElements::typedElement typdel);
 
+  virtual bool createInputFile(particleBeam* beamBefore,unsigned int numeroDeb, unsigned int numeroFin, string workingDir) = 0;
+  virtual bool execute(string workingDir) = 0;
+  virtual bool buildBeamAfterElements(string workingDir) = 0;
 
-  virtual bool createInputFile(particleBeam* beamBefore,unsigned int numeroDeb, unsigned int numeroFin, string workingDir) = 0;
-
-
-  virtual bool  execute(string workingDir) = 0;
-
- virtual bool buildBeamAfterElements(string workingDir) = 0;
-
-    /** Color of the background of this sofware
-     Should be a valid Css name as FFEEDD
-     */
-    virtual string getColor() = 0;
-
-    /** Name of this software
-     */
-    inline string getName() const {
-      return nameOfSoftware_.getString();
-    }
-
+  /** Color of the background of this sofware
+      Should be a valid Css name as FFEEDD
+  */
+  virtual string getColor() = 0;
+  
+  /** Name of this software
+   */
+  inline string getName() const {
+    return nameOfSoftware_.getString();
+  }
 };
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/dataManager.h	(revision 431)
@@ -14,4 +14,6 @@
 #include "nomDeLogiciel.h"
 
+#include "sectorParameters.h" //xx
+
 class PspaApplication;
 
@@ -21,4 +23,5 @@
  public:
   
+  dataManager() {;}
   dataManager(PspaApplication*);
   virtual ~dataManager();
@@ -27,4 +30,7 @@
   inline globalParameters* getGlobalParameters()  {return &globParam_;}
   inline particleBeam* getCurrentBeam() {return currentBeam_;}
+
+  // xx
+  inline sectorParameters* getSectorParameters() {return &sectorParam_;}
     
   particleBeam* getDiagnosticBeam(unsigned index);
@@ -50,6 +56,5 @@
   
   void initializeExecution();
-//  trivaluedBool checkExecute(string& diagnostic);
-//  trivaluedBool checkElementsForExec(nomDeLogiciel logiciel, unsigned indexDeb, unsigned indexFin, string& diagnostic);
+
   bool executeAll();
  
@@ -81,24 +86,6 @@
     return &diagnosticBeam_.back();
   }
-  
-  /** return a specific jobList index
-      return NULL if the index does not exist
-  */
-  
-  /* inline sectionToExecute* getJobListAt(int a) { */
-    /*     if (a < 0) return NULL; */
-    /*     if (a >= getJobListSize()) return NULL; */
-    /*     return jobList_[a]; */
-    /* } */
-
-  
-  
-    /* inline const abstractSoftware* getSoftwareOfSection( int index) const { */
-    /*     if (index < 0) return NULL; */
-    /*     if (index >= getJobListSize()) return NULL; */
-    /* 	return jobList_[index]->getSoftware(); */
-    /* } */
     
-    /** Clear a specific jobList */
+  /** Clear a specific jobList */
   void clearSectionToExecute(int a);
     
@@ -106,4 +93,5 @@
 
   globalParameters globParam_;
+  sectorParameters sectorParam_; //xx
   particleBeam* currentBeam_;
   PspaApplication* pspa_;
@@ -113,7 +101,4 @@
   vector<particleBeam> diagnosticBeam_;
   vector<unsigned> indexElementToIndexDiag_;
-  // numeroElementToIndexDiag_[k] contient, pour l'element d'index k, l'indice ind tel que diagnosticBeam_[ind]
-  // soit le faisceau resultat, en l'etat qu'il doit avoir apres l'element k
-  
   vector<sectionToExecute*> jobList_;
   
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/elementMultipole.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/elementMultipole.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/elementMultipole.h	(revision 431)
@@ -0,0 +1,29 @@
+#ifndef MPOLEDEFINITION_SEEN
+#define MPOLEDEFINITION_SEEN
+
+#include <string>
+#include "abstractElement.h"
+
+using namespace std;
+
+class elementMultipole : public abstractElement
+{
+  int order_;
+  double component_;
+    
+ public:
+  
+  elementMultipole();
+  ~elementMultipole() {;}
+    
+  virtual string* getParametersString() const;
+  virtual void setParametersString(string* param);
+  virtual vector< pair<string, vector<string> > > parametersToSoftware () const;
+  virtual string FileOutputFlow() const;
+  virtual void FileInput(ifstream& ifs);
+  virtual void InputRep(UAPNode* root);
+
+  /** return a string with all parameters and value */
+  string print();
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/nomDeLogiciel.h	(revision 431)
@@ -6,24 +6,20 @@
 using namespace std;
 
-
-
 class nomDeLogiciel
 {
 
- public: 
-
-
+ public : 
+  
   enum Logiciel
   {
-    parmela, transport, generator, useraction, test, unknownSoftware
+    parmela, transport, generator, useraction, test, madx, unknownSoftware
   };
-
+  
     
- private:
+ private :
 
   Logiciel program_;
   std::string progString_;
-  //  int value_;
-  
+   
   static Logiciel fromString( std::string s);
   static std::string toString( Logiciel lg);  
@@ -31,6 +27,5 @@
   
  public : 
-  // constructors
-  
+ 
   nomDeLogiciel();  
   nomDeLogiciel(const string& s);  
@@ -39,21 +34,14 @@
   
   inline std::string getString() const {return progString_;}
+  inline nomDeLogiciel::Logiciel getLogiciel() const {return program_;}
 
-  inline nomDeLogiciel::Logiciel getLogiciel() const { return program_; }
-
-    /** Color of the background of the sofware
-     Should be a valid Css name as FFEEDD
-     */
+  /** Color of the background of the sofware
+      Should be a valid Css name as FFEEDD
+  */
   inline std::string  getColor() const {return getWtColor(program_);}
   // operators
-  
   nomDeLogiciel& operator= (const nomDeLogiciel& nl);  
   bool operator== (const nomDeLogiciel& nl);  
   bool operator!= (const nomDeLogiciel& nl);
-  
 };
-
-
-
-
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/nomdElements.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/nomdElements.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/nomdElements.h	(revision 431)
@@ -13,5 +13,5 @@
  public :
 
-enum typedElement {beam, RFgun, drift, cell, bend, soleno, fit, snapshot, inconnu};
+  enum typedElement {beam, RFgun, drift, cell, bend, soleno, fit, snapshot, mpole, inconnu};
 
  private : 
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/sectorParameters.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/sectorParameters.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/sectorParameters.h	(revision 431)
@@ -0,0 +1,37 @@
+#ifndef SECTORPARAMETERS_SEEN
+#define SECTORPARAMETERS_SEEN
+
+#include <string>
+#include <iostream>
+#include "UAP/UAPNode.hpp"
+using namespace std;
+
+class sectorParameters  
+{
+  string geometry_;
+  int nCells_;
+  double lCell_;
+  double pc_;
+
+  int nbParam_;
+  string* parametersString_;
+
+ public :
+  
+  sectorParameters();
+  ~sectorParameters() {
+    if(parametersString_ != NULL) delete [] parametersString_;
+  }
+  
+  string* getParametersString() const;
+  void setParametersString(string*);
+  void raz();
+  string FileOutputFlow() const;
+  void FileInput(ifstream&);
+  void InputRep(UAPNode* root);
+
+  int getNumberOfCells() const;
+  double getCellLength() const;
+  double getParticleMomentum() const;
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareGenerator.h	(revision 431)
@@ -7,42 +7,26 @@
 class softwareGenerator : public abstractSoftware
 {
+ protected : 
+  
+  bool beamFromGenerator(string beamFileName, string workingDir, vector<double>& centroid, bareParticle& refPart,vector<bareParticle>& particles, vector<bareParticle>& passiveParticles );
 
- protected : 
-
-
-
- bool beamFromGenerator(string beamFileName, string workingDir, vector<double>& centroid, bareParticle& refPart,vector<bareParticle>& particles, vector<bareParticle>& passiveParticles );
-
-
- string elementsData(const vector< pair<string, vector<string> > >& donnees) const;
- string rfgunData(const vector< pair<string, vector<string> > >& donnees) const;
-
+  string elementsData(const vector< pair<string, vector<string> > >& donnees) const;
+ 
+  string rfgunData(const vector< pair<string, vector<string> > >& donnees) const;
 
  public : 
-
-
-    softwareGenerator();
-    
-    softwareGenerator(string inputFileName, globalParameters* globals, dataManager* dt);
+  
+  softwareGenerator();  
+  softwareGenerator(string inputFileName, globalParameters* globals, dataManager* dt);
 
   virtual ~softwareGenerator() {;}
 
-
   virtual bool createInputFile(particleBeam* beamBefore, unsigned int numeroDeb, unsigned int numeroFin, string workingDir);
-
-
-  virtual bool  execute(string workingDir);
-
-
+  virtual bool execute(string workingDir);
   virtual bool buildBeamAfterElements(string workingDir);
 
-    inline string getColor() {
-        return "#a3c0ed";
-    }
-
-    /* inline string getName() const { */
-    /*     return "generator"; */
-    /* } */
+  inline string getColor() {
+    return "#a3c0ed";
+  }
 };
-
 #endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareMadx.h	(revision 431)
@@ -0,0 +1,25 @@
+#ifndef SOFTWAREMADX_SEEN
+#define SOFTWAREMADX_SEEN
+
+#include "abstractSoftware.h"
+
+typedef pair<string, vector<string> > statements;
+
+class softwareMadx : public abstractSoftware
+{
+  string inputFormat(const vector<statements>&) const;
+
+ public :
+  
+  softwareMadx();
+  softwareMadx(string,sectorParameters*,dataManager*);
+  virtual ~softwareMadx() {;}
+
+  virtual bool createInputFile(particleBeam*,unsigned int,unsigned int,string);
+  virtual bool execute(string);
+  virtual bool buildBeamAfterElements(string);
+  
+  inline string getColor() {return "#ecc38e";}
+  //{ return "#FFFF00"; }
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUnknown.h
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUnknown.h	(revision 431)
+++ /Interface_Web/trunk/pspaWT/sources/controler/include/softwareUnknown.h	(revision 431)
@@ -0,0 +1,19 @@
+#ifndef SOFTWAREUNKNOWN_SEEN
+#define SOFTWAREUNKNOWN_SEEN
+
+#include "abstractSoftware.h"
+
+class softwareUnknown : public abstractSoftware
+{
+ public :
+  
+  softwareUnknown();
+  virtual ~softwareUnknown() {;}
+
+  virtual bool createInputFile(particleBeam*,unsigned int,unsigned int,string);
+  virtual bool execute(string);
+  virtual bool buildBeamAfterElements(string);
+  
+  inline string getColor() {return "#FFFFFF";}
+};
+#endif
Index: /Interface_Web/trunk/pspaWT/sources/controler/src/abstractElement.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/abstractElement.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/abstractElement.cc	(revision 431)
@@ -5,7 +5,5 @@
 #include "abstractElement.h"
 
-abstractElement::abstractElement() 
-//: nameOfSoftware_(NULL)
-  : abstractSoftware_(NULL)
+abstractElement::abstractElement() : abstractSoftware_(NULL)
 {
   setDefaultValues();
@@ -14,7 +12,5 @@
 }
 
-abstractElement::abstractElement(string lab)
-  //: nameOfSoftware_(NULL)
-  : abstractSoftware_(NULL)
+abstractElement::abstractElement(string lab) : abstractSoftware_(NULL)
 {
   specificName_ = lab;
@@ -27,5 +23,4 @@
 {
   if (parametersString_ != NULL) delete [] parametersString_ ;
-  //  if ( nameOfSoftware_ != NULL ) delete nameOfSoftware_;
 }
 
@@ -62,16 +57,11 @@
 }
 
-string abstractElement::getLabel() const
-{
+string abstractElement::getLabel() const {
   return specificName_;
 }
 
-
-nomdElements abstractElement::getNomdElement() const 
-{
+nomdElements abstractElement::getNomdElement() const {
   return elementName_;
 }
-
-
 
 double abstractElement::getLenghtOfElement() const { 
@@ -83,9 +73,5 @@
 }
 
-
 double abstractElement::getInitialKineticEnergy() const {
   return 0.0;
 }
-
-
-
Index: /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc
===================================================================
--- /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc	(revision 430)
+++ /Interface_Web/trunk/pspaWT/sources/controler/src/abstractSoftware.cc	(revision 431)
@@ -2,14 +2,18 @@
 #include "dataManager.h"
 #include <algorithm>
+
 abstractSoftware::abstractSoftware()
 {
   globParamPtr_ = NULL;
+  sectParamPtr_ = NULL; //xx
   dataManager_ = NULL;
   nameOfSoftware_ = nomDeLogiciel("unknownSoftware");
 }
 
-abstractSoftware::abstractSoftware(string inputFileName, globalParameters* globals, dataManager* dt) {
+abstractSoftware::abstractSoftware(string inputFileName, globalParameters* globals, dataManager* dt) 
+{
   inputFileName_ = inputFileName;
   globParamPtr_ = globals;
+  sectParamPtr_ = NULL; //xx
   dataManager_ = dt;
   numeroDeb_ = 0;
@@ -18,5 +22,17 @@
 }
 
-bool abstractSoftware::initComputationLimits(unsigned int numeroDeb,unsigned int numeroFin) {
+abstractSoftware::abstractSoftware(string inputFileName,sectorParameters* lattice,dataManager* dt) 
+{
+  inputFileName_ = inputFileName;
+  globParamPtr_ = NULL;
+  sectParamPtr_ = lattice;
+  dataManager_ = dt;
+  numeroDeb_ = 0;
+  numeroFin_ = 0;
+  nameOfSoftware_ = nomDeLogiciel("unknownSoftware");
+}
+
+bool abstractSoftware::initComputationLimits(unsigned int numeroDeb,unsigned int numeroFin) 
+{
   numeroDeb_ = numeroDeb;
   numeroFin_ = numeroFin;
@@ -24,7 +40,8 @@
 }
 
-bool abstractSoftware::ComputationLimitsOk() const {
-  if (   numeroDeb_ < 1 ||  numeroFin_ < 1 || numeroDeb_ > dataManager_->getBeamLineSize() || numeroFin_ > dataManager_->getBeamLineSize() ) {
-  dataManager_->consoleMessage(" abstractSoftware::initComputationLimit : numero of element out of limits in software " + getName() );
+bool abstractSoftware::ComputationLimitsOk() const 
+{
+  if (numeroDeb_ < 1 || numeroFin_ < 1 || numeroDeb_ > dataManager_->getBeamLineSize() || numeroFin_ > dataManager_->getBeamLineSize() ) {
+    dataManager_->consoleMessage(" abstractSoftware::initComputationLimit : num of element out of limits in software " + getName() );
     return false;
   } else {
@@ -33,6 +50,6 @@
 }
 
-
-void abstractSoftware::registerElement(nomdElements::typedElement nomdel,trivaluedBool b) {
+void abstractSoftware::registerElement(nomdElements::typedElement nomdel,trivaluedBool b) 
+{
   if (b == TBoolIgnore) {
     ignoredElements_.push_back(nomdel);
@@ -42,20 +59,26 @@
 }
 
-trivaluedBool abstractSoftware::doAcceptElement(nomdElements::typedElement typdel) {
-  if (acceptedElements_.size() == 0) {
+trivaluedBool abstractSoftware::doAcceptElement(nomdElements::typedElement typdel) 
+{
+
+  //xx
+  if (acceptedElements_.size() == 0 && nameOfSoftware_ != nomDeLogiciel::unknownSoftware) {
     return TBoolError;
   }
-  if ( std::find(acceptedElements_.begin(), acceptedElements_.end(), typdel) != acceptedElements_.end()) {
+
+  if (std::find(acceptedElements_.begin(),acceptedElements_.end(),typdel) != acceptedElements_.end()) {
     return TBoolOk;
   }
+
   if (ignoredElements_.size() == 0) {
     return TBoolError;
   }
-  if ( std::find(ignoredElements_.begin(), ignoredElements_.end(), typdel) != ignoredElements_.end()) {
+
+  if (std::find(ignoredElements_.begin(),ignoredElements_.end(),typdel) != ignoredElements_.end()) {
     return TBoolIgnore;
   }
+
   return TBoolOk;
 }
-
 
 bool abstractSoftware::launchJob(string commandLine, string& resul)
@@ -66,8 +89,7 @@
   ostringstream sortie;
   if (pp == NULL) {
-    sortie << " launching  failed : " << commandLine << endl;
+    sortie << " launching failed : " << commandLine << endl;
     ExecuteStatus = false;
   } else {
-    cout << " executing command :  "  << commandLine << endl;
     // on copie la sortie dans le fichier assigne
     char buf[132];
